import urllib
import json
import ssl
from jnpr.junos import Device
from jnpr.junos.utils.config import Config
from jnpr.junos.op.routes import RouteTable
from jnpr.junos.op.ethport import EthPortTable
from jnpr.junos.op.vlan import VlanTable
from jnpr.junos.op.vlan_no_els import VlanNoElsTable
from jnpr.junos.op.poe import PoeTable
from jnpr.junos.exception import *
from jnpr.junos.factory import loadyaml
from pprint import pprint as pprint

#finding ping sensors down in prtg

input_url = 'https://172.30.183.221/api/table.json?content=sensors&columns=objid,group,downtimesince,parentid&count=99999&filter_status=5&filter_type=ping&sortby=lastup&username=API&passhash=3317184866'
ctx = ssl.create_default_context()
ctx.check_hostname = False
ctx.verify_mode = ssl.CERT_NONE
url = urllib.urlopen(input_url, context=ctx)
json_data = url.read()    
data = json.loads(json_data)['sensors']

#filtering sensors down for .2 .254 down between 2 and 10 minutes

#swap comments below to filter down between 2 minutes and 10 minutes
filter_objid = [str(d['parentid']) for d in data] 
#filter_objid = [str(d['parentid']) for d in data if d['downtimesince_raw'] >= 120 and d['downtimesince_raw'] <= 600]
if len(filter_objid) == 0:
    quit("Nothing to reboot.")
filter_objid = "&filter_objid=".join(filter_objid)
input_url = 'https://172.30.183.221/api/table.json?content=devices&columns=objid,host&filter_objid='+filter_objid+'&count=99999&username=API&passhash=3317184866'
ctx = ssl.create_default_context()
ctx.check_hostname = False
ctx.verify_mode = ssl.CERT_NONE
url = urllib.urlopen(input_url, context=ctx)
json_data = url.read()    
data = json.loads(json_data)['devices']

#swap comments below to filter only ips ending in .2 or .2540
down = list(set([d['host'] for d in data]))
#down = list(set([d['host'] for d in data if d['host'].split('.')[3] in ['2', '254']]))

if len(down) == 0:
    quit("Nothing to reboot.")

print len(down),"Down:", down
reboots = {}
login = {'user':'netbot','password':'fd38*M0i'}

#checking routes from man 1 2 and 3
print 'Checking routes from mains'
for main in ['192.168.180.105','192.168.180.101', '192.168.180.107']:
    try:
        Device.auto_probe = 1
        dev = Device(main, user=login['user'],password=login['password'])
        dev.open()
        route_table = RouteTable(dev)
        for ip in down:
            ip_route = route_table.get(ip).items()
            if ip_route[0][0] != '0.0.0.0/0':
                next_hop = ip_route[0][1][0][1]
                try:
                    if next_hop == None: 
                        switch = main
                    else:
                        switch = '192.168.180.'+ip_route[0][1][0][1].split('.')[3]
                    if switch in reboots:
                        reboots[switch].append(ip)
                    else:
                        reboots[switch] = [ip]
                except Exception as err:
                    print err.args
        dev.close()
    except Exception as err:
        print err.args
        
print 'Rebooting poes'
#pprint(reboots)

for switch, ips in reboots.items():
    print("-------------------------------------")
    print("connecting to", switch)
    commit = 0
    try:
        interfaces = []
        Device.auto_probe = 1
        dev = Device(switch, user=login['user'],password=login['password'])
        dev.open()
        interfaces = []
        route_table = RouteTable(dev)
        poe_table = PoeTable(dev).get()
        vlan_table = VlanTable(dev)
        
        if len(vlan_table.get().items()) == 0:
            vlan_table = VlanNoElsTable(dev)
        
        for ip in ips:
            
            ge =  False
            ip_route = route_table.get(ip).items()[0][1][2][1]
            #direct to physical interfaces
            if "ge-" in ip_route:
                ge = ip_route.split('.')[0]
            #physical interface is member of a vlan/irb interface
            elif "vlan" in ip_route or "irb" in ip_route:
                member = vlan_table.get(vlan_name=ip_route.split('.')[1]).items()[0][1][4][1]
                if "ge-" in member:
                    ge = member.split('.')[0]
            if ge is not False:
                interfaces.append(ge)
        
        #avoid duplicate commands, this should be obsolete if we are filtering only .2 and .254 ips        
        interfaces = list(set(interfaces))
        
        for interface in interfaces:
            poe_enabled = poe_table[interface].items()[6][1]
            if poe_enabled == "Enabled":
                
                print "set poe interface",interface,"disabled (simulation)"
                #do real command here
                commit+=1
        
        if commit > 0:
            print "commit confirmed 1 (simulation)"
            #do real command
        
        dev.close()
        print switch, "closed"
    
    except Exception as err:
        print err.args
        
        
